OpenAPI

Open-source projects categorized as OpenAPI

Top 23 OpenAPI Open-Source Projects

  1. open-webui

    User-friendly AI Interface (Supports Ollama, OpenAI API, ...)

    Project mention: Mastering Free Autonomous Agents: Self-Hosting Hermes with OpenRouter | dev.to | 2026-09-07

    An agent constrained to a local terminal is limited in scope. By enabling the OpenAI-compatible API server, you can integrate Hermes Agent with external interfaces like Open WebUI. To expose your agent to the internet securely, use Pinggy, which allows you to create a secure tunnel to your local endpoint without complex network configuration:

  2. AppSignal

    AppSignal knows why the f*#k it crashed. Stop vibe-debugging. Every exception, every backtrace, grouped so you see patterns, not noise.

    AppSignal logo
  3. fastapi

    FastAPI framework, high performance, easy to learn, fast to code, ready for production

    Project mention: Rebuilding the Cerebras Knowledge Base: an MCP server | dev.to | 2026-08-16

    // search("how do I add middleware") {"source_id": "issue_3027", "score": 0.0164, "snippet": "# How to add a header field to the request in a middleware?", "url": "https://github.com/fastapi/fastapi/issues/3027"} // search_code("def jsonable_encoder") {"source_id": "fastapi/encoders.py#jsonable_encoder", "score": 1.0, "snippet": "fastapi/encoders.py jsonable_encoder", "url": "fastapi/encoders.py#L129-L192"} // who_knows("dependency injection") {"author": "sneakers-the-rat", "score": 5.0, "issues": ["issue_13399"]}

  4. bruno

    Opensource IDE For Exploring and Testing API's (lightweight alternative to Postman/Insomnia)

    Project mention: Postman Without an Account: What Still Works in 2026 | dev.to | 2026-08-25

    Full disclosure, since you're on Bruno's blog: this is where we tell you about Bruno. We'll keep it factual.

  5. full-stack-fastapi-template

    Full-stack web application template with FastAPI, React, SQLModel, PostgreSQL, Vite, Tailwind CSS, shadcn/ui, FastAPI Cloud, and Docker Compose.

  6. OpenAPI-Specification

    The OpenAPI Specification Repository

    Project mention: OpenAPI Initiative AI Policy | news.ycombinator.com | 2026-07-05
  7. swagger-ui

    Swagger UI is a collection of HTML, JavaScript, and CSS assets that dynamically generate beautiful documentation from a Swagger-compliant API.

    Project mention: Publishing OAS-Based API Doc on GitHub Pages | dev.to | 2026-03-15

    Most of the content is the same as what is written here.

  8. openapi-generator

    OpenAPI Generator allows generation of API client libraries (SDK generation), server stubs, documentation and configuration automatically given an OpenAPI Spec (v2, v3)

    Project mention: Stop Advertising in Your Commits | news.ycombinator.com | 2026-05-26

    To be fair I've never used Laravel - but I do have a memory of code generators/scaffolders inserting files that made clear they were responsible for work

    /*

    * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    * Do not edit the class manually.

    */

  9. Kargo

    Stop Scripting Promotions. Start Shipping with Kargo. Kargo automates promotion across dev, staging, and prod with approval gates and verification. Open source, built by the team behind Argo CD. Download now.

    Kargo logo
  10. redoc

    πŸ“˜ OpenAPI/Swagger-generated API Reference Documentation

  11. grpc-gateway

    gRPC to JSON proxy generator following the gRPC HTTP spec

    Project mention: Why gRPC Is Ideal for High-Performance APIs | dev.to | 2026-01-20

    gRPC-Gateway reads protobuf service definitions and generates a reverse proxy that translates RESTful JSON HTTP calls into gRPC, based on annotations like google.api.http. (GitHub)

  12. scalar

    Scalar is an open-source API platform:γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€πŸŒ Modern REST API Clientγ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€πŸ“– Beautiful API Referencesγ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€γ€€βœ¨ 1st-Class OpenAPI/Swagger Support

    Project mention: Build a versioned Laravel API with auto-generated OpenAPI docs in 10 minutes | dev.to | 2026-06-10

    Open GET /api/doc in a browser. You don't get a raw JSON file β€” you get a ready-to-use interactive API reference (rendered with Scalar), with a version switcher across v1, v2, … already wired up. The package walked your controllers, read those docblocks, and produced a complete OpenAPI 3.0 document β€” parameters, enums, response schemas, the lot. These docs can't drift, because they are the code.

  13. swag

    Automatically generate RESTful API documentation with Swagger 2.0 for Go.

    Project mention: Experiencia profesional de testing en Golang | dev.to | 2025-12-19
  14. fastapi_mcp

    Expose your FastAPI endpoints as Model Context Protocol (MCP) tools, with Auth!

  15. mitmproxy2swagger

    Automagically reverse-engineer REST APIs via capturing traffic

    Project mention: Show HN: CLI to order groceries via reverse-engineered REWE API (Haskell) | news.ycombinator.com | 2026-03-29

    I just had the best time learning about the REWE (German supermarket chain) API, how they use mTLS and what the workflows are. Also `mitmproxy2swagger`[1] is a great tool to create OpenAPI spec automatically.

    And then 2026 feels like the perfect time writing Haskell. The code is handwritten, but whenever I got stuck with the build system or was just not getting the types right, I could fall back to ask AI to unblock me. It was never that smooth before.

    Finally the best side projects are the ones you actually use and this one will be used for all my future grocery shopping.

    [1]https://github.com/alufers/mitmproxy2swagger

  16. django-ninja

    πŸ’¨ Fast, Async-ready, Openapi, type hints based framework for building APIs

    Project mention: Removing React.js from the codebase and adapting Htmx for UI interactivity | news.ycombinator.com | 2026-07-27

    Using Django w/ frontend frameworks has been a struggle for me. (I only dabble as a hobbyist.) I think splitting the backend off into a restful API makes the marriage work. I've looked at django-rest-framework (https://www.django-rest-framework.org/) and django-ninja (https://django-ninja.dev/). Of course,, then you're discarding a lot of batteries that come with the django framework. Perhaps using Django templates for admin / internal facing work only, and React for customer-facing sites can be a healthy compromise?

  17. API Platform

    πŸ•ΈοΈ Create REST and GraphQL APIs, scaffold Jamstack webapps, stream changes in real-time.

  18. oapi-codegen

    Generate Go client and server boilerplate from OpenAPI 3 specifications

    Project mention: Htmx 4.0, the first JavaScript library to release exclusively on the Game Boy | news.ycombinator.com | 2026-07-26

    I don't want to ID my account but they basically look like:

    - OpenAPI API spec and using https://github.com/oapi-codegen/oapi-codegen/ to generate the types, server interface, and client library

    - Standard library http package for the server implementation

    - api served from /api route, htmx webpage served from /

    - no ORM, mostly using database/sql for DB transactions, maybe reaching for a query builder library for more complex queries like complex search functionality

    - Local S3 compatible object store for dynamic binary data like user-uploaded images and video. Local filesystem can be fine for small scale stuff.

  19. litestar

    Light, flexible and extensible ASGI framework | Built to scale

    Project mention: Hyperflask – Full stack Flask and Htmx framework | news.ycombinator.com | 2025-10-16

    A lot of people in this thread mentioning the limitations of Flask and β€œwhy not FastAPI” etc - but I’ve found Litestar to be the best alternative and it has htmx support out of the box.

    https://litestar.dev/

  20. mockoon

    Mockoon is the easiest and quickest way to run mock APIs locally. No remote deployment, no account required, open source.

    Project mention: أدواΨͺ CLI Ω…Ψ¬Ψ§Ω†ΩŠΨ© مفΨͺوحة Ψ§Ω„Ω…Ψ΅Ψ―Ψ± Ω„Ω…Ψ­Ψ§ΩƒΨ§Ψ© Ψ§Ω„Ω€ API | dev.to | 2026-07-10

    Ψ§Ω„Ω…Ψ³Ψͺودع: mockoon/mockoon

  21. openapi-typescript

    Generate TypeScript types from OpenAPI 3 specs

    Project mention: How to type third-party API responses in TypeScript (without lying to your compiler) | dev.to | 2026-06-13

    REST with an OpenAPI/Swagger spec β†’ openapi-typescript turns the spec into types.

  22. swagger-core

    Examples and server integrations for generating the Swagger API Specification, which enables easy access to your REST API

  23. NSwag

    The Swagger/OpenAPI toolchain for .NET, ASP.NET Core and TypeScript.

    Project mention: Why Startups and IndieDevs Should Choose Monolith First, Lessons From My Micro-SaaS Project, For ... | dev.to | 2026-01-09

    Type sharing is possible (think NSwag or OpenAPI codegen).

  24. goa

    Design-first Go framework that generates API code, documentation, and clients. Define once in an elegant DSL, deploy as HTTP and gRPC services with zero drift between code and docs.

    Project mention: DSLs Enable Reliable Use of LLMs | news.ycombinator.com | 2026-07-15

    Anecdotal, but I have built from scratch a fairly large OpenAPI-compliant service using the Goa dsl (https://goa.design) and a coding agent and I've suspected for a while that the reason I've been as productive as I have with few blind alleys is that Goa kept the mistake surface pretty constrained. I also like not having the model generate boilerplate, as Goa's tooling does all that so much more cheaply. YMMV.

  25. springfox

    Automated JSON API documentation for API's built with Spring

  26. SaaSHub

    SaaSHub - Software Alternatives and Reviews. SaaSHub helps you find the best software and product alternatives

    SaaSHub logo
NOTE: The open source projects on this list are ordered by number of github stars. The number of mentions indicates repo mentiontions in the last 12 Months or since we started tracking (Dec 2020).

OpenAPI discussion

Log in or Post with

OpenAPI related posts

Index

What are some of the best open-source OpenAPI projects? This list will help you:

# Project Stars
1 open-webui 151,481
2 fastapi 102,237
3 bruno 46,916
4 full-stack-fastapi-template 45,519
5 OpenAPI-Specification 31,213
6 swagger-ui 29,004
7 openapi-generator 26,738
8 redoc 25,906
9 grpc-gateway 20,002
10 scalar 16,088
11 swag 13,015
12 fastapi_mcp 12,004
13 mitmproxy2swagger 9,605
14 django-ninja 9,188
15 API Platform 9,184
16 oapi-codegen 8,566
17 litestar 8,455
18 mockoon 8,397
19 openapi-typescript 8,363
20 swagger-core 7,531
21 NSwag 7,365
22 goa 6,100
23 springfox 5,926

Sponsored
AppSignal knows why the f*#k it crashed.
Stop vibe-debugging. Every exception, every backtrace, grouped so you see patterns, not noise.
www.appsignal.com